#include <string.h>

#include "SWDefs.h"

#include "SW.h"
#include "IStyles.h"
#include "cbx_0.h"
#include "cbx_1.h"
#include "cbx_2.h"
#include "cbx_4.h"
#include "lv.h"
#include "undo.h"
#include "LineData.h"
#include "pbx.h"
#include "Text.h"
#include "WordList.h"
#include "SAccessor.h"
#include "History.h"
#include "ILexer.h"
#include "LexBase.h"
#include "LexScript.h"
#include "LexASP.h"

void LexASP::ColourisePiece(SAccessor &sc) {
	// Possibly exit current state to HTML base state
	if (sc.Match('%', '>')) {
		if (sc.state == (SCE_ASP_ASPAT + baseState)) {
			SW_BYTE s[100];
			int len = sc.GetCurrentLowered(s, 100);
			int lexNum = FindSubLexer(s, len);
			if (lexNum >= 0) {
				defaultLexer->Append(sc.startSeg, lexNum);
			}
			sc.SetState(SCE_ASP_ASP + baseState);
			sc.Forward();
			sc.ForwardSetState(lexerHTML->GetBaseState());
		} else {
			SubLexer *sl = slScriptsRoot;
			while (sl != NULL) {
				if (sl->lexer->InStateRange(sc.state)) {
					sc.SetState(SCE_ASP_ASP + baseState);
					sc.Forward();
					sc.ForwardSetState(lexerHTML->GetBaseState());
				}
				sl = sl->slNext;
			}
		}
	}

	// Handle some ASP script
	if ((lexerHTML != NULL) && (lexerHTML->InStateRange(sc.state))) {
		lexerHTML->ColourisePiece(sc);
	} else {
		ColourisePieceSubLexer(sc);
	}

	// Enter new sc.state
	if ((lexerHTML == NULL) || (!lexerHTML->InStateRange(sc.state)) || (lexerHTML->CanBeInterrupted(sc.state))) {
		if (sc.Match('<', '%')) {
			//if (sc.state == SCE_H_TAGUNKNOWN)
			//	sc.ChangeState(SCE_H_ASP);
			//else
				sc.SetState(SCE_ASP_ASP + baseState);
			sc.Forward();
			sc.Forward();
			if (sc.ch == '@') {
				sc.ForwardSetState(SCE_ASP_ASPAT + baseState);
			} else {
				if (sc.ch == '=') {
					sc.Forward();
				}
				SwitchToSubLexer(sc, defaultLexer->Value());
			}
		}
	}
}

void LexASP::Colourise(SAccessor &sc) {

	for (; sc.More(); sc.Forward()) {
		ColourisePiece(sc);
	}
	sc.Complete();
}
