class LexASP : public LexScript {
	typedef LexScript super;
public:
	enum { SCE_ASP_ASP = 0 };
	enum { SCE_ASP_ASPAT = 1 };

	ILexer *lexerHTML;
	History *defaultLexer;

	LexASP() {
		thisStates = 2;
		lexerHTML = NULL;
		slScriptsRoot = NULL;
		defaultLexer = new History(0);
	}

	~LexASP() {
		while (slScriptsRoot != NULL) {
			SubLexer *slToFree = slScriptsRoot;
			slScriptsRoot = slScriptsRoot->slNext;
			delete slToFree;
		}
		delete defaultLexer;
	}

	SW_OVERRIDE void SetKeyWords(int n, WordList *keyWordsN) {
	}

	SW_OVERRIDE void InvalidateAfter(int position) {
		defaultLexer->InvalidateAfter(position);
		if (lexerHTML != NULL) {
			lexerHTML->InvalidateAfter(position);
		}
		super::InvalidateAfter(position);
	}
	SW_OVERRIDE void ColourisePiece(SAccessor &sc);
	SW_OVERRIDE void Colourise(SAccessor &sc);

	SW_OVERRIDE bool CanBeInterrupted(int state) {
		return false;
	}

	SW_OVERRIDE void AllocateStates(int startAllocation) {
		subStates = 0;
		int allocatedState = startAllocation;
		// Start with HTML states so the default 0 is HTML
		if (lexerHTML != NULL) {
			subStates += lexerHTML->States();
			lexerHTML->SetBaseState(allocatedState);
			allocatedState += lexerHTML->States();
		}
		super::AllocateStates(allocatedState);
	}

	void SetHTML(ILexer *lx) {
		lexerHTML = lx;
		AllocateStates(baseAllocation);
	}
};