class SubLexer {
public:
	SubLexer *slNext;
	ILexer *lexer;
	Text *name;
	Text *name2;
	SubLexer(ILexer *lexer_, Text *name_, Text *name2_) {
		slNext = NULL;
		lexer = lexer_;
		name = name_;
		name2 = name2_;
	}
	~SubLexer() {
		delete name;
		delete name2;
	}
};

class LexScript : public LexBase {
public:
	SubLexer *slScriptsRoot;

	LexScript() {
		slScriptsRoot = NULL;
	}

	~LexScript() {
		while (slScriptsRoot != NULL) {
			SubLexer *slToFree = slScriptsRoot;
			slScriptsRoot = slScriptsRoot->slNext;
			delete slToFree;
		}
	}

	int FindSubLexer(SW_BYTE *s, int len) {
		SubLexer *sl = slScriptsRoot;
		int lexNum=0;
		while (sl != NULL) {
			if (sl->name->IsIn(s, 0, len)) {
				return lexNum;
			} else if ((sl->name2 != NULL) && (sl->name2->IsIn(s, 0, len))) {
				return lexNum;
			}
			sl = sl->slNext;
			lexNum++;
		}
		return -1;
	}

	void SwitchToSubLexer(SAccessor &sc, int lexNum) {
		SubLexer *sl = slScriptsRoot;
		while ((sl != NULL) && (lexNum > 0)) {
			sl = sl->slNext;
			lexNum--;
		}
		if (sl != NULL) {
			sc.SetState(sl->lexer->GetBaseState());
		}
	}

	void ColourisePieceSubLexer(SAccessor &sc) {
		SubLexer *sl = slScriptsRoot;
		while (sl != NULL) {
			if (sl->lexer->InStateRange(sc.state)) {
				sl->lexer->ColourisePiece(sc);
				break;
			}
			sl = sl->slNext;
		}
	}

	SW_OVERRIDE void InvalidateAfter(int position) {
		SubLexer *sl = slScriptsRoot;
		while (sl != NULL) {
			sl->lexer->InvalidateAfter(position);
			sl = sl->slNext;
		}
	}

	SW_OVERRIDE void AllocateStates(int startAllocation) {
		int allocatedState = startAllocation;
		baseState = allocatedState;
		allocatedState += thisStates;
		SubLexer *sl = slScriptsRoot;
		while (sl != NULL) {
			subStates += sl->lexer->States();
			sl->lexer->SetBaseState(allocatedState);
			allocatedState += sl->lexer->States();
			sl = sl->slNext;
		}
	}

	virtual void SetScript(ILexer *lx, Text *name, Text *name2) {
		SubLexer *sl = new SubLexer(lx, name, name2);
		if (slScriptsRoot != NULL) {
			SubLexer *slLast = slScriptsRoot;
			while (slLast->slNext != NULL) {
				slLast = slLast->slNext;
			}
			slLast->slNext = sl;
		} else {
			slScriptsRoot = sl;
		}
		AllocateStates(baseAllocation);
	}
};