// A simple counted string class without a terminating NUL
class Text {
private:
	SW_BYTE *value;
	int len;
public:
#ifdef SW_CXX
	Text(const char *s) {
		len = 0;
		while (s[len]) {
			len++;
		}
		value = new SW_BYTE[len];
		for (int i=0; i<len; i++) {
			value[i] = s[i];
		}
	}
	~Text() {
		delete []value;
	}
#endif
#ifdef SW_CS
	Text(System.String s) {
		value = System.Text.Encoding.UTF8.GetBytes(s);
		len = value.Length;
	}
#endif
#ifdef SW_JAVA
	Text(String s) {
		try {
			value = s.getBytes("UTF8");
			len = value.length;
		} catch (java.io.UnsupportedEncodingException x) {
			value = null;
			len = 0;
		}
	}
#endif

	SW_BYTE CharAt(int position) {
		return value[position];
	}

	SW_BYTE *Data() {
		return value;
	}

	int Length() {
		return len;
	}

	bool Equals(SW_BYTE *other, int lenOther) {
		if (len != lenOther)
			return false;
		for (int i=0; i< len; i++) {
			if (value[i] != other[i])
				return false;
		}
		return true;
	}
	bool Equals(Text *other) {
		if (len != other->len)
			return false;
		for (int i=0; i< len; i++) {
			if (value[i] != other->value[i])
				return false;
		}
		return true;
	}
	bool IsIn(SW_BYTE *other, int posStart, int lenOther) {
		for (int i=posStart; i <= (lenOther-len); i++) {
			bool found = true;
			for (int j=0; j < len; j++) {
				if (value[j] != other[j+i]) {
					found = false;
					break;
				}
			}
			if (found) {
				return true;
			}
		}
		return false;
	}
};

