// SinkWorld demonstration program - Managed C++ version
// Copyright 2001 Neil Hodgson
#include <string.h>
#using <mscorlib.dll>
#include "SW.hpp"
#include "cbx.hpp"
#include "pbx.hpp"
#include "SWTest.hpp"

int main() {
	SWTest.WriteLine("Start test");
	cbx *buffer = new cbx(20,100);
	char test[] = "abcde";
	try {
		buffer->InsertString(1, test, 1);
	} catch (BadPositionException *) {
		SWTest.Write("Caught\n");
	}
	int lenTest = strlen(test);
	buffer->InsertString(0, test, lenTest);
	SWTest.Assert(buffer->Length() == lenTest);
	char ret __nogc[3];
	buffer->RetrieveString(1, ret, 3);
	for (int h = 0; h < 3; h++) {
		SWTest.Assert(ret[h] == test[h + 1]);
	}
	for (int i = 0; i < lenTest; i++) {
		SWTest.Assert(test[i] == buffer->CharAt(i));
		SWTest.Write(i);
		SWTest.Write(":");
		SWTest.Write(buffer->CharAt(i));
		SWTest.Write(" ");
	}
	SWTest.Write("\n");
	buffer->DeleteChars(1,2);
	SWTest.Assert(buffer->Length() == lenTest-2);
	for (int j = -1; j < buffer->Length()+1; j++) {
		SWTest.Write(j);
		SWTest.Write("=");
		SWTest.Write(buffer->CharAt(j));
		SWTest.Write(" ");
	}
	SWTest.Write("\n");
	char shortInsert[] = "bc";
	buffer->InsertString(1, shortInsert, 2);
	SWTest.Assert(buffer->Length() == lenTest);
	for (int k = 0; k < lenTest; k++) {
		SWTest.Assert(test[k] == buffer->CharAt(k));
		SWTest.Write(k);
		SWTest.Write(":");
		SWTest.Write(buffer->CharAt(k));
		SWTest.Write(" ");
	}
	SWTest.Write("\n");
	double st = SWTest.Now();
	char longtest[]="ghijklmnopqrstuvwxyz";
	for (int l = 0; l < 10000; l++) {
		for (int m = 0; m < 20; m++) {
			buffer->InsertString(1, longtest, m+1);
		}
	}
	
	pbx *pbuffer = new pbx(1024,1024);
	pbuffer->InsertString(0, test, lenTest);
	SWTest.Assert(pbuffer->Length() == lenTest);
	for (int n = 0; n < lenTest; n++) {
		SWTest.Assert(test[n] == pbuffer->CharAt(n));
		SWTest.Write(n);
		SWTest.Write(":");
		SWTest.Write(buffer->CharAt(n));
		SWTest.Write(" ");
	}
	SWTest.Write("\n");

	double en = SWTest.Now();
	SWTest.Write("Completed test took ");
	SWTest.Write(en-st);
	SWTest.Write(" seconds\n");
	return 0;
}
