/// Name will be changed to SplitText
class pbx {
private:
	cbx_1 *substance;
	lv *lines;
	int styleWidth;
	LineData *pldRoot;
	int encoding;
	bool *leads;	// Only valid for encoding=ENCODING_DBCS

	void BasicInsertString(int position, SW_BYTE s[], int insertLength);
	void BasicDeleteChars(int position, int deleteLength);
	
protected:
	virtual void InsertLine(int lineInsert, int position);
	virtual void RemoveLine(int lineRemove);

public:
	IStyles *style;
	undoStack *us;

	enum { ENCODING_BYTE = 0 };
	enum { ENCODING_DBCS = 1 };
	enum { ENCODING_UTF8 = 2 };

	pbx(int initialLength, int growSize_, int styleWidth_);
	~pbx();

	SW_BYTE CharAt(int position) {
		return substance->CharAt(position);
	}

	int StyleAt(int position);
	int Length();

	/// Retrieving positions outside the range of the buffer fails
	void RetrieveString(int position, SW_BYTE s[], int retrieveLength);
	void DiscardLines();
	void RecreateLines();
	void InsertString(int position, SW_BYTE s[], int insertLength);
	void FillStyleRange(int position, int val, int fillLength);
	void DeleteRange(int position, int deleteLength);
	int Lines();
	int PositionFromLine(int line);
	int LineEndPositionFromLine(int line);
	int LineFromPosition(int position);
	
	void AddPerLineData(LineData *pld);
	void RemovePerLineData(LineData *pld);
	
	/// Undo and redo
	void SetUndoCollection(bool collectUndo);
	bool IsCollectingUndo();
	void BeginUndoAction();
	void EndUndoAction();
	void DeleteUndoHistory();
	bool CanUndo();
	int StartUndo();
	undoAction *GetUndoStep();
	void PerformUndoAction();
	void PerformUndoStep();
	bool CanRedo();
	int StartRedo();
	undoAction *GetRedoStep();
	void PerformRedoAction();
	void PerformRedoStep();
	
	int ClampPositionIntoDocument(int position);
	bool IsCrLf(int position);
	bool IsDBCS(int position);
	int LenChar(int position);
	int CharValue(int position);
	int MovePositionOutsideChar(int position, int moveDirection, bool checkLineEnd);
};
